{

6502 core test env.

Configured for 96Mhz HYBRID board.  Nothing requires this however, so edit for your setup.  (Done in TV Driver)

All that's provided here right now is a STRING compatable font, Text Display Driver, Screen Buffer, Pointers to things


}

CON
  ' Set up the processor clock in the standard way for 80MHz on HYBRID
  ' You will want to edit this to reflect your clock setup
  ' Also necessary is editing the pin definitions, and that's done in the driver itself.
_CLKMODE = xtal1 + pll16x
_XINFREQ = 6_000_000 + 0000

VAR
  'byte          displayb[1024]   'allocate display buffer in HUB RAM  40x24 probably not a good idea to have dynamic screen
                                  'right now, so it's gonna be at the TOP of HUB ram. 
  word          displayb
  
  'byte          r6502_Program[1024]  '1K of 6502 code space for now 

  word          r6502_program

  
  long          index            'just an index...
  long          fonttab          'pointer to HUB Font Table
  long          params[4]                                    'The address of this array gets 
                '[0] screen memory                            passed to the TV driver.
                '[1] font table
                '[2] pix_mode not yet implemented...
                '[3] colors, or 16 bit mode = $00
  
OBJ
  tv : "8x8_NTSC_40x24_TV"        'the actual TV display driver
  font : "Font_ATARI"             'a font table!  Actually, this uses the AIGeneric system for font files!
  cpu : "spud6502.spin"
 
PUB start |  Temp

    init_pointers
    locate_code(00)               'not sure how this is gonna get done.
    init_display
    clear_screen

    print_xy(4,1, @welcome)   'Let somebody know what the heck is going on!
   
    
{we do stuff here with the emulated CPU...}

     cpu.execute(r6502_program)



PUB  init_pointers

     displayb := $7bff                'top of HUB - ~1Kb for display
     'r6502_program := $6000           '6502 below screen for now
                                      'don't want to fight relocatable code right now...

     r6502_program := @test_program

     
PUB  locate_code(length)

     'just a stub...




PUB  init_display

    params[0] := displayb                               'HUB Address of Text Display Buffer
    params[1] := font.GetPtrToFontTable                 'HUB Address of font table used by TV display  ATASCII for now...
    params[2] := $0000_0000                             'Not implemented....  
    params[3] := $0000502                               'Text display colors (Black and White default)

    tv.start(@params)                                   'start the tv cog & pass it the parameter block
      
PUB  clear_screen | c

    c := 32
    repeat index from 0 to 1024
       byte [displayb] [index] := c                     'clear the screen


PRI  print_xy (x, y, str_addr) | i
     'brutally simple print routine
     'no clipping, no wrap around, no formatting, no nothing
     i := 0
     i := i + x + (y * 40)
     bytemove (displayb + i, str_addr, strsize(str_addr))

    

DAT

Welcome  Byte "6502 Testing in Progress...", 0


DAT

test_program

{ Program Origin $6000

                zero = $30
                nine = $39

              screen = $7bff

              numbers = $7cc7

        lda #zero       'get zero digit loaded
        ldx #8          'we are gonna do 8 digits
digits  sta numbers, x          'put them on screen, right to left
        dex                     'next digit?
        cpx #0                  'done ?
        bne digits              'no, continue writing digits to screen!

                                'yes, move on to counting on them....


'hand assembly until I get the 400 sorted, or DASM or something...
'this code is relocatable and simple, so it can be put right into the test proggy with no worries
'which is where it is right now!

}


byte byte  $a9, $30          '         lda #zero
byte byte  $a2, $08          '         ldx #8
byte byte  $9d, $c7, $7c     'digits   sta numbers, x    (check endian on this one)
byte byte  $ca               '         dex
byte byte  $e0, $00          '         cpx #0
byte byte  $d0, $f8          '         bne digits        (check branch offset)
























   